## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 24
%bcond_without check
%global debug_package %{nil}

%global crate backtrace

Name:           rust-backtrace
Version:        0.3.67
Release:        %autorelease
Summary:        Library to acquire a stack trace (backtrace) at runtime in a Rust program

License:        MIT OR Apache-2.0
URL:            https://crates.io/crates/backtrace
Source:         %{crates_source}
# Automatically generated patch to strip foreign dependencies
Patch:          backtrace-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# * drop "accuracy" test (requires crates to be built in dylib mode)
# * drop "current-exe-mismatch" test (fails on i686 for unknown reasons)
# * exclude files for upstream CI
Patch:          backtrace-fix-metadata.diff

BuildRequires:  rust-packaging >= 21

%global _description %{expand:
A library to acquire a stack trace (backtrace) at runtime in a Rust
program.}

%description %{_description}

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE-APACHE
%license %{crate_instdir}/LICENSE-MIT
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+cpp_demangle-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+cpp_demangle-devel %{_description}

This package contains library source intended for building other packages which
use the "cpp_demangle" feature of the "%{crate}" crate.

%files       -n %{name}+cpp_demangle-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+gimli-symbolize-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+gimli-symbolize-devel %{_description}

This package contains library source intended for building other packages which
use the "gimli-symbolize" feature of the "%{crate}" crate.

%files       -n %{name}+gimli-symbolize-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+libbacktrace-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+libbacktrace-devel %{_description}

This package contains library source intended for building other packages which
use the "libbacktrace" feature of the "%{crate}" crate.

%files       -n %{name}+libbacktrace-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+rustc-serialize-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+rustc-serialize-devel %{_description}

This package contains library source intended for building other packages which
use the "rustc-serialize" feature of the "%{crate}" crate.

%files       -n %{name}+rustc-serialize-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serde-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serde-devel %{_description}

This package contains library source intended for building other packages which
use the "serde" feature of the "%{crate}" crate.

%files       -n %{name}+serde-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serialize-rustc-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serialize-rustc-devel %{_description}

This package contains library source intended for building other packages which
use the "serialize-rustc" feature of the "%{crate}" crate.

%files       -n %{name}+serialize-rustc-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serialize-serde-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serialize-serde-devel %{_description}

This package contains library source intended for building other packages which
use the "serialize-serde" feature of the "%{crate}" crate.

%files       -n %{name}+serialize-serde-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+std-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+std-devel %{_description}

This package contains library source intended for building other packages which
use the "std" feature of the "%{crate}" crate.

%files       -n %{name}+std-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
# drop "accuracy" test (requires crates to be built in dylib mode)
# drop "current-exe-mismatch" test (fails on i686 for unknown reasons)
rm -r tests/accuracy/
rm tests/current-exe-mismatch.rs
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build

%install
%cargo_install

%if %{with check}
%check
# https://github.com/rust-lang/backtrace-rs/issues/204
# * tests/smoke.rs/smoke_test_frames: fails on all architectures
# * tests/smoke.rs/sp_smoke_test: crashes when frame pointers are enabled on x86_64
# * backtrace_new_unresolved_should_start_with_call_site_trace: fails on aarch64, ppc64le, s390x
%cargo_test -- -- --skip smoke_test_frames --skip sp_smoke_test --skip backtrace_new_unresolved_should_start_with_call_site_trace
%endif

%changelog
* Thu Mar 30 2023 Fabio Valentini <decathorpe@gmail.com> - 0.3.67-2
- Skip a test that fails on i686 for unknown reasons

* Thu Mar 30 2023 Fabio Valentini <decathorpe@gmail.com> - 0.3.67-1
- Update to version 0.3.67; Fixes RHBZ#2153583

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.66-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Jan 11 2023 Fabio Valentini <decathorpe@gmail.com> - 0.3.66-3
- Skip a test that fails on x86_64 if frame pointers are enabled

* Tue Aug 09 2022 Fabio Valentini <decathorpe@gmail.com> - 0.3.66-2
- Bump addr2line from 0.17 to 0.18

* Tue Aug 09 2022 Fabio Valentini <decathorpe@gmail.com> - 0.3.66-1
- Update to version 0.3.66; Fixes RHBZ#2076300

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.64-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Feb 03 2022 Fabio Valentini <decathorpe@gmail.com> - 0.3.64-1
- Update to version 0.3.64; Fixes RHBZ#2016017

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.61-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Sep 21 2021 Fabio Valentini <decathorpe@gmail.com> - 0.3.61-1
- Update to version 0.3.61; Fixes RHBZ#1967769

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.59-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sat May 08 2021 Fabio Valentini <decathorpe@gmail.com> - 0.3.59-1
- Update to version 0.3.59.

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.55-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Dec 02 2020 Fabio Valentini <decathorpe@gmail.com> - 0.3.55-1
- Update to version 0.3.55.
- Fixes RHBZ#1900082

* Sat Nov 07 2020 Fabio Valentini <decathorpe@gmail.com> - 0.3.54-1
- Update to version 0.3.54.
- Fixes RHBZ#1883637

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.50-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jul 22 2020 Josh Stone <jistone@redhat.com> - 0.3.50-1
- Update to 0.3.50

* Mon Jun 15 2020 Josh Stone <jistone@redhat.com> - 0.3.49-1
- Update to 0.3.49

* Thu May 14 2020 Josh Stone <jistone@redhat.com> - 0.3.48-1
- Update to 0.3.48

* Tue May 12 2020 Josh Stone <jistone@redhat.com> - 0.3.47-1
- Update to 0.3.47

* Wed Apr 01 2020 Josh Stone <jistone@redhat.com> - 0.3.46-1
- Update to 0.3.46

* Wed Mar 04 2020 Josh Stone <jistone@redhat.com> - 0.3.45-1
- Update to 0.3.45

* Wed Feb 26 2020 Josh Stone <jistone@redhat.com> - 0.3.44-2
- Bump goblin to 0.2

* Wed Feb 19 2020 Josh Stone <jistone@redhat.com> - 0.3.44-1
- Update to 0.3.44

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.40-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Dec 16 2019 Josh Stone <jistone@redhat.com> - 0.3.40-1
- Update to 0.3.40

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.30-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Jun 22 09:21:35 CEST 2019 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.30-2
- Regenerate

* Tue Jun 04 2019 Josh Stone <jistone@redhat.com> - 0.3.30-1
- Update to 0.3.30

* Mon Jun 03 2019 Josh Stone <jistone@redhat.com> - 0.3.28-1
- Update to 0.3.28

* Sat Jun 01 2019 Josh Stone <jistone@redhat.com> - 0.3.26-1
- Update to 0.3.26

* Wed May 15 08:23:12 CEST 2019 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.16-1
- Update to 0.3.16

* Fri Apr 05 2019 Josh Stone <jistone@redhat.com> - 0.3.15-1
- Update to 0.3.15

* Sun Mar 10 2019 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.14-2
- Do not pull optional dependencies

* Tue Feb 19 2019 Josh Stone <jistone@redhat.com> - 0.3.14-1
- Update to 0.3.14

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.13-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Jan 10 2019 Josh Stone <jistone@redhat.com> - 0.3.13-1
- Update to 0.3.13

* Thu Dec 20 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.12-2
- Run tests in infrastructure

* Wed Dec 12 2018 Josh Stone <jistone@redhat.com> - 0.3.12-1
- Update to 0.3.12

* Fri Nov 02 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.9-3
- Adapt to new packaging

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Jun 29 2018 Josh Stone <jistone@redhat.com> - 0.3.9-1
- Update to 0.3.9

* Wed May 23 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.8-1
- Update to 0.3.8

* Fri May 04 2018 Josh Stone <jistone@redhat.com> - 0.3.7-1
- Update to 0.3.7

* Sat Apr 14 2018 Josh Stone <jistone@redhat.com> - 0.3.6-1
- Update to 0.3.6

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Jan 08 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.5-2
- Rebuild for rust-packaging v5

* Thu Jan 04 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.3.5-1
- Initial package

